#include "mypile_u32.h"


pile_u32 *Pile_u32_new()
{
    pile_u32 *p = calloc(1, sizeof(pile_u32));
    
    if(p==NULL)
    {
        fprintf(stderr, "Pile_u32_new : Erreur Allocation Memoire.\n");
        return(NULL);
    }
    
    return p;
}


_Bool Pile_u32_isEmpty(pile_u32 *p)
{
    return p->tete==NULL;
}


maillon_u32 *Maillon_u32_new()
{
    maillon_u32 *m = calloc(1, sizeof(maillon_u32));
    
    if(m==NULL)
    {
        fprintf(stderr, "Maillon_u32_new : Erreur Allocation Memoire.\n");
        return(NULL);
    }

    return m;
}


uint32_t Pile_u32_pop(pile_u32 *p)
{
    uint32_t r;
    maillon_u32 *tmp;
    
    if (Pile_u32_isEmpty(p))
    {
        fprintf(stderr, "Erreur : Pile_u32_pop alors que la pile est vide.\n");
        assert(0);
    }
    
    tmp = p->tete;
    r=tmp->data;
    p->tete = p->tete->next;
    p->taille-=1;
    free(tmp);
    return(r);
}


void Pile_u32_push(pile_u32 *p, uint32_t d)
{
    maillon_u32 *m = Maillon_u32_new();
    assert(m!=NULL);
    m->data=d;
    m->next = p->tete;
    p->tete = m;
    p->taille+=1;
}


void Pile_u32_free(pile_u32 *p)
{
    while (!Pile_u32_isEmpty(p))
        Pile_u32_pop(p);
    free(p);
}



