#include <stdio.h>
#include "mypile.h"


pile *mypile_uint32_new()
{
    return Pile_new(sizeof(uint32_t));
}


uint32_t mypile_uint32_pop(pile *p)
{
    maillon *m = Pile_pop(p);
    uint32_t r = *((uint32_t *)(m+1));
    Maillon_free(m);
    return(r);
}


void mypile_uint32_push(pile *p, uint32_t data)
{
    maillon *m = Maillon_new(p);
    uint32_t *e = (uint32_t*)(m+1);
    *e = data;
    Pile_push(p, m);
}


int main(int argc, const char * argv[]) {
    pile *p = mypile_uint32_new();
    mypile_uint32_push(p, 6);
    mypile_uint32_push(p, 9);
    mypile_uint32_push(p, 3);
    mypile_uint32_push(p, 0);
    printf("%u\n", mypile_uint32_pop(p));
    mypile_uint32_push(p, 12);
    printf("%u\n", mypile_uint32_pop(p));
    printf("%u\n", mypile_uint32_pop(p));
    printf("%u\n", mypile_uint32_pop(p));
    printf("%u\n", mypile_uint32_pop(p));
    
    return(0);
}
