#include "mypile.h"


pile *Pile_new(size_t size_element)
{
    pile *p = calloc(1, sizeof(pile));
    
    if(p==NULL)
    {
        fprintf(stderr, "Pile_new : Erreur Allocation Memoire.\n");
        return(NULL);
    }
    
    p->size_element = size_element;
    
    return p;
}


_Bool Pile_isEmpty(pile *p)
{
    return p->tete==NULL;
}


maillon *Maillon_new(pile *p)
{
    maillon *m = calloc(1, sizeof(maillon)+p->size_element);
    
    if(m==NULL)
    {
        fprintf(stderr, "Maillon_new : Erreur Allocation Memoire.\n");
        return(NULL);
    }

    return m;
}


void Maillon_free(maillon *m)
{
    free(m);
}


maillon* Pile_pop(pile *p)
{
    maillon *tmp;
    
    if (Pile_isEmpty(p))
    {
        fprintf(stderr, "Attention, pop appele sur pile vide.\n");
        return(NULL);
    }
    
    tmp = p->tete;
    p->tete = p->tete->next;
    p->taille-=1;
    return(tmp);
}


void Pile_push(pile *p, maillon *m)
{
    m->next = p->tete;
    p->tete = m;
    p->taille+=1;
}



